// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from scenario_execution_interfaces:srv/ExecuteScenario.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "scenario_execution_interfaces/srv/execute_scenario.hpp"


#ifndef SCENARIO_EXECUTION_INTERFACES__SRV__DETAIL__EXECUTE_SCENARIO__STRUCT_HPP_
#define SCENARIO_EXECUTION_INTERFACES__SRV__DETAIL__EXECUTE_SCENARIO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'scenario'
#include "scenario_execution_interfaces/msg/detail/scenario__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Request __attribute__((deprecated))
#else
# define DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Request __declspec(deprecated)
#endif

namespace scenario_execution_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ExecuteScenario_Request_
{
  using Type = ExecuteScenario_Request_<ContainerAllocator>;

  explicit ExecuteScenario_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : scenario(_init)
  {
    (void)_init;
  }

  explicit ExecuteScenario_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : scenario(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _scenario_type =
    scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>;
  _scenario_type scenario;

  // setters for named parameter idiom
  Type & set__scenario(
    const scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> & _arg)
  {
    this->scenario = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Request
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Request
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteScenario_Request_ & other) const
  {
    if (this->scenario != other.scenario) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteScenario_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteScenario_Request_

// alias to use template instance with default allocator
using ExecuteScenario_Request =
  scenario_execution_interfaces::srv::ExecuteScenario_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace scenario_execution_interfaces


#ifndef _WIN32
# define DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Response __attribute__((deprecated))
#else
# define DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Response __declspec(deprecated)
#endif

namespace scenario_execution_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ExecuteScenario_Response_
{
  using Type = ExecuteScenario_Response_<ContainerAllocator>;

  explicit ExecuteScenario_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = false;
    }
  }

  explicit ExecuteScenario_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = false;
    }
  }

  // field types and members
  using _result_type =
    bool;
  _result_type result;

  // setters for named parameter idiom
  Type & set__result(
    const bool & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Response
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Response
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteScenario_Response_ & other) const
  {
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteScenario_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteScenario_Response_

// alias to use template instance with default allocator
using ExecuteScenario_Response =
  scenario_execution_interfaces::srv::ExecuteScenario_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace scenario_execution_interfaces


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Event __attribute__((deprecated))
#else
# define DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Event __declspec(deprecated)
#endif

namespace scenario_execution_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ExecuteScenario_Event_
{
  using Type = ExecuteScenario_Event_<ContainerAllocator>;

  explicit ExecuteScenario_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit ExecuteScenario_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<scenario_execution_interfaces::srv::ExecuteScenario_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<scenario_execution_interfaces::srv::ExecuteScenario_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Event
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__scenario_execution_interfaces__srv__ExecuteScenario_Event
    std::shared_ptr<scenario_execution_interfaces::srv::ExecuteScenario_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteScenario_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteScenario_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteScenario_Event_

// alias to use template instance with default allocator
using ExecuteScenario_Event =
  scenario_execution_interfaces::srv::ExecuteScenario_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace scenario_execution_interfaces

namespace scenario_execution_interfaces
{

namespace srv
{

struct ExecuteScenario
{
  using Request = scenario_execution_interfaces::srv::ExecuteScenario_Request;
  using Response = scenario_execution_interfaces::srv::ExecuteScenario_Response;
  using Event = scenario_execution_interfaces::srv::ExecuteScenario_Event;
};

}  // namespace srv

}  // namespace scenario_execution_interfaces

#endif  // SCENARIO_EXECUTION_INTERFACES__SRV__DETAIL__EXECUTE_SCENARIO__STRUCT_HPP_
